<?php
/**
Plugin Name: eRoom - Zoom Meetings & Webinar
Plugin URI: https://wordpress.org/plugins/zoom-video-conference/
Description: eRoom Zoom Meetings & Webinar WordPress Plugin provides you with great functionality of managing Zoom meetings, scheduling options, and users directly from your WordPress dashboard.
The plugin is a free yet robust and reliable extension that enables direct integration of the world's leading video conferencing tool Zoom with your WordPress website.
Author: StylemixThemes
Author URI: https://stylemixthemes.com/
Text Domain: eroom-zoom-meetings-webinar
Version: 1.3.2
 */

if( !defined( 'ABSPATH' ) ) exit; //Exit if accessed directly

define( 'STM_ZOOM_VERSION', '1.3.2' );
define( 'STM_ZOOM_DB_VERSION', '1.2.8' );
define( 'STM_ZOOM_FILE', __FILE__ );
define( 'STM_ZOOM_PATH', dirname( STM_ZOOM_FILE ) );
define( 'STM_ZOOM_URL', plugin_dir_url( STM_ZOOM_FILE ) );

if ( ! is_textdomain_loaded( 'eroom-zoom-meetings-webinar' ) ) {
    load_plugin_textdomain(
        'eroom-zoom-meetings-webinar',
        false,
        'eroom-zoom-meetings-webinar/languages'
    );
}

require_once STM_ZOOM_PATH . '/zoom-app/vendor/autoload.php';
require_once STM_ZOOM_PATH . '/includes/helpers.php';
require_once STM_ZOOM_PATH . '/nuxy/NUXY.php';
require_once STM_ZOOM_PATH . '/zoom-conference/init.php';
require_once STM_ZOOM_PATH . '/vc/main.php';

if ( did_action( 'elementor/loaded' ) ) {
    require( STM_ZOOM_PATH . '/elementor/StmZoomElementor.php' );
}

/**  Init Freemius */
if ( ! function_exists( 'stm_fs' ) ) {
    // Create a helper function for easy SDK access.
    function stm_fs() {
        global $stm_fs;

        if ( ! isset( $stm_fs ) ) {
            // Include Freemius SDK.
            if ( file_exists( WP_CONTENT_DIR . '/plugins/eroom-zoom-meetings-webinar/libs/freemius/start.php' ) ) {
                require_once WP_CONTENT_DIR . '/plugins/eroom-zoom-meetings-webinar/libs/freemius/start.php';
            }

            $stm_fs = fs_dynamic_init( array(
                'id'                  => '9697',
                'slug'                => 'eroom-zoom-meetings-webinar',
                'type'                => 'plugin',
                'public_key'          => 'pk_004979649a1120e59326364703e10',
                'is_premium'          => false,
                'has_addons'          => false,
                'has_paid_plans'      => false,
                'menu'                => array(
                    'slug'           => 'stm_zoom',
                    'first-path'     => 'admin.php?page=stm_zoom_settings',
                    'support'        => false,
                    'account'        => false,
                    'contact'        => false,
                    'affiliation'    => false,
                    'addons'         => false,
                ),
            ) );
        }

        return $stm_fs;
    }

    // Init Freemius.
    stm_fs();
    // Signal that SDK was initiated.
    do_action( 'stm_fs_loaded' );

    if ( is_admin() ) {
        require_once STM_ZOOM_PATH . '/includes/item-announcements.php';
        require_once STM_ZOOM_PATH . '/includes/conflux.php';
        require_once STM_ZOOM_PATH . "/libs/admin-notification/admin-notification.php";
        $init_data = [
            'plugin_title' => 'eRoom - Zoom Meetings & Webinar',
            'plugin_name' => 'eroom-zoom-meetings-webinar',
            'plugin_file' => STM_ZOOM_FILE,
            'logo' => STM_ZOOM_URL . 'assets/images/zoom_icon.png'
        ];
        stm_admin_notification_init( $init_data );
    }
}

